/*
 *  sherrors.h  Shell error codes
 *
 *                          Open Watcom Project
 *
 * Copyright (c) 2004-2008 The Open Watcom Contributors. All Rights Reserved.
 *
 *    This file is automatically generated. Do not edit directly.
 *
 * =========================================================================
 */

#ifndef _SHERRORS_H_INCLUDED
#define _SHERRORS_H_INCLUDED

#ifndef _SHERROR_
#define _SHERROR_

#if !defined(_ENABLE_AUTODEPEND)
  #pragma read_only_file;
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Shell error codes */
#define COPYENGINE_S_YES                    0x00270001L
#define COPYENGINE_S_NOT_HANDLED            0x00270003L
#define COPYENGINE_S_USER_RETRY             0x00270004L
#define COPYENGINE_S_USER_IGNORED           0x00270005L
#define COPYENGINE_S_MERGE                  0x00270006L
#define COPYENGINE_S_DONT_PROCESS_CHILDREN  0x00270008L
#define COPYENGINE_S_ALREADY_DONE           0x0027000AL
#define COPYENGINE_S_PENDING                0x0027000BL
#define COPYENGINE_S_KEEP_BOTH              0x0027000CL
#define COPYENGINE_S_CLOSE_PROGRAM          0x0027000DL
#define COPYENGINE_E_USER_CANCELLED         0x80270000L
#define COPYENGINE_E_CANCELLED              0x80270001L
#define COPYENGINE_E_REQUIRES_ELEVATION     0x80270002L
#define COPYENGINE_E_SAME_FILE              0x80270003L
#define COPYENGINE_E_DIFF_DIR               0x80270004L
#define COPYENGINE_E_MANY_SRC_1_DEST        0x80270005L
#define COPYENGINE_E_DEST_SUBTREE           0x80270009L
#define COPYENGINE_E_DEST_SAME_TREE         0x8027000AL
#define COPYENGINE_E_FLD_IS_FILE_DEST       0x8027000BL
#define COPYENGINE_E_FILE_IS_FLD_DEST       0x8027000CL
#define COPYENGINE_E_FILE_TOO_LARGE         0x8027000DL
#define COPYENGINE_E_REMOVABLE_FULL         0x8027000EL
#define COPYENGINE_E_DEST_IS_RO_CD          0x8027000FL
#define COPYENGINE_E_DEST_IS_RW_CD          0x80270010L
#define COPYENGINE_E_DEST_IS_R_CD           0x80270011L
#define COPYENGINE_E_DEST_IS_RO_DVD         0x80270012L
#define COPYENGINE_E_DEST_IS_RW_DVD         0x80270013L
#define COPYENGINE_E_DEST_IS_R_DVD          0x80270014L
#define COPYENGINE_E_SRC_IS_RO_CD           0x80270015L
#define COPYENGINE_E_SRC_IS_RW_CD           0x80270016L
#define COPYENGINE_E_SRC_IS_R_CD            0x80270017L
#define COPYENGINE_E_SRC_IS_RO_DVD          0x80270018L
#define COPYENGINE_E_SRC_IS_RW_DVD          0x80270019L
#define COPYENGINE_E_SRC_IS_R_DVD           0x8027001AL
#define COPYENGINE_E_INVALID_FILE_SRC       0x8027001BL
#define COPYENGINE_E_INVALID_FILE_DEST      0x8027001CL
#define COPYENGINE_E_PATH_TOO_DEEP_SRC      0x8027001DL
#define COPYENGINE_E_PATH_TOO_DEEP_DEST     0x8027001EL
#define COPYENGINE_E_ROOT_DIR_SRC           0x8027001FL
#define COPYENGINE_E_ROOT_DIR_DEST          0x80270020L
#define COPYENGINE_E_ACCESS_DENIED_SRC      0x80270021L
#define COPYENGINE_E_ACCESS_DENIED_DEST     0x80270022L
#define COPYENGINE_E_PATH_NOT_FOUND_SRC     0x80270023L
#define COPYENGINE_E_PATH_NOT_FOUND_DEST    0x80270024L
#define COPYENGINE_E_NET_DISCONNECT_SRC     0x80270025L
#define COPYENGINE_E_NET_DISCONNECT_DEST    0x80270026L
#define COPYENGINE_E_SHARING_VIOLATION_SRC  0x80270027L
#define COPYENGINE_E_SHARING_VIOLATION_DEST 0x80270028L
#define COPYENGINE_E_ALREADY_EXISTS_NORMAL  0x80270029L
#define COPYENGINE_E_ALREADY_EXISTS_READONLY    0x8027002AL
#define COPYENGINE_E_ALREADY_EXISTS_SYSTEM  0x8027002BL
#define COPYENGINE_E_ALREADY_EXISTS_FOLDER  0x8027002CL
#define COPYENGINE_E_STREAM_LOSS            0x8027002DL
#define COPYENGINE_E_EA_LOSS                0x8027002EL
#define COPYENGINE_E_PROPERTY_LOSS          0x8027002FL
#define COPYENGINE_E_PROPERTIES_LOSS        0x80270030L
#define COPYENGINE_E_ENCRYPTION_LOSS        0x80270031L
#define COPYENGINE_E_DISK_FULL              0x80270032L
#define COPYENGINE_E_DISK_FULL_CLEAN        0x80270033L
#define COPYENGINE_E_CANT_REACH_SOURCE      0x80270035L
#define COPYENGINE_E_RECYCLE_UNKNOWN_ERROR  0x80270035L
#define COPYENGINE_E_RECYCLE_FORCE_NUKE     0x80270036L
#define COPYENGINE_E_RECYCLE_SIZE_TOO_BIG   0x80270037L
#define COPYENGINE_E_RECYCLE_PATH_TOO_LONG  0x80270038L
#define COPYENGINE_E_RECYCLE_BIN_NOT_FOUND  0x8027003AL
#define COPYENGINE_E_NEWFILE_NAME_TOO_LONG  0x8027003BL
#define COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG    0x8027003CL
#define COPYENGINE_E_DIR_NOT_EMPTY          0x8027003DL
#define NETCACHE_E_NEGATIVE_CACHE           0x80270100L
#define EXECUTE_E_LAUNCH_APPLICATION        0x80270101L
#define SHELL_E_WRONG_BITDEPTH              0x80270102L

#ifdef __cplusplus
} /* End of extern "C" */
#endif

#endif /* _SHERROR_ */
#endif /* _SHERRORS_H_INCLUDED */

